/**
    author: shadow
    2018.8.16
*/

(function (window) {

    if (!Object.assign) {
        Object.defineProperty(Object, "assign", {
            enumerable: false,
            configurable: true,
            writable: true,
            value: function (target, firstSource) {
                if (target === undefined || target === null)
                    throw new TypeError("Cannot convert first argument to object");
                var to = Object(target);
                for (var i = 1; i < arguments.length; i++) {
                    var nextSource = arguments[i];
                    if (nextSource === undefined || nextSource === null) continue;
                    var keysArray = Object.keys(Object(nextSource));
                    for (var nextIndex = 0, len = keysArray.length; nextIndex < len; nextIndex++) {
                        var nextKey = keysArray[nextIndex];
                        var desc = Object.getOwnPropertyDescriptor(nextSource, nextKey);
                        if (desc !== undefined && desc.enumerable) to[nextKey] = nextSource[nextKey];
                    }
                }
                return to;
            }
        });
    }

    var u = {};

    u.apiready = function (callback) {

        function init() {
        }

        apiready = function () {
          //用于模拟iphonex
          u.safeArea = api.safeArea;
          u.fixHeaderBar();

          //监听网络状态
          api.addEventListener({
              name: 'offline'
          }, function (ret, err) {
              api.toast({
                  msg: "断网了！"
              })
          });
          api.addEventListener({
              name: 'online'
          }, function (ret, err) {
              api.toast({
                  msg: "已连接到网络！"
              })
          })

          init();

          if (typeof callback == 'function')
            callback();
        }
    }

    u.fixHeaderBar = function() {
	    var page_header = document.getElementsByClassName("headerBar")[0];
      if(!page_header)
      	return;

    	if(page_header.getAttribute("fix-ios-bar") == "false")
    		return;

      page_header.style.paddingTop = u.safeArea.top + "px";
    }

    u.openWin = function (options) {

        var loginStatus = $api.getStorage("maokeLoginMode");
        var needLoginList = ["user_message", "net_search_module", "mk_open_partake", "feedback", "my_account",
            "set_info", "mk_collection", "my_team", "mk_partake", "mk_customer", "mk_about", "mk_shop"];

        var defaults = {
            reload: true,
            delay: 10,
            pageParam: {
                enableTD: true,
            },
            closeWin: [],
        },
            settings = Object.assign(defaults, options);

        if (!settings.name || !settings.url)
            return;

        if (u.isInArray(needLoginList, settings.name) && !loginStatus) {
            u.openWin({
                name: 'login',
                url: 'widget://views/login.html',
                reload: true,
                allowEdit: true
            })
            return;
        }

        //把待关闭页面传到目标页中删除
        settings.closeWin.map(function (val, index) {
            api.execScript({
                name: val,
                script: "setTimeout(function() {api.closeWin();}, 500)"
            });
        })

        api.openWin(settings);
    }

    u.toast = function (msg, location) {
        api.toast({
            msg: msg,
            duration: 1000,
            location: location || 'middle'
        });

    }

    //下拉刷新
    u.pullRefresh = function (options) {
        var defaults = {
            container: document.querySelector('.main-warpper'),
            triggerDistance: 50,
            success: function (ret) { },
        },
            settings = Object.assign(defaults, options);

        var pullRefresh = new auiPullToRefresh(settings, function (ret) {
            if (ret.status == "success") {
                if (typeof settings.success == 'function')
                    settings.success(ret);

                setTimeout(function () {
                    pullRefresh.cancelLoading();
                }, 1000)
            }
        })
    }

    //下拉加载
    u.scrollToBottom = function (options) {
        var defaults = {
            name: 'scrolltobottom',
            extra: { threshold: 50 },
            success: function (ret) { },
        },
            settings = Object.assign(defaults, options);

        api.addEventListener(settings, function (ret) {
            if (typeof settings.success == 'function') {
                settings.success(ret);
            }
        })
    }

    u.ajax = function (options) {
        var beforeSendClock = null;
        var token = api_token(APITOKEN, APICRPYT);

        var defaults = {
            url: '',
            encode: true,
            method: 'post',
            cache: false,
            timeout: 30,
            dataType: 'json',
            data: {},
            charset: 'utf-8',
            progress: {
                style: 'default',
                title: '加载中...',
                text: '请等候...',
                model: false,
            },
            beforeSend: function () { },
            error: function (err) {
                api.toast({
                    msg: err.msg,
                    location: "location",
                    global: false,
                });
            },
            success: function (ret) { },
            complete: function () { }
        },
            settings = Object.assign(defaults, options);

        if (settings.progress !== false) {
            beforeSendClock = setTimeout(function () {
                api.showProgress(settings.progress);
            }, 500)
        }

        if (typeof settings.beforeSend == 'function')
            settings.beforeSend();


        settings.data = Object.assign({
            token: token.token,
            timestamp: token.timestamp,
            noncestr: token.noncestr,
            sign: token.sign,
        }, options.data),

            api.ajax({
                url: settings.url,
                encode: settings.encode,
                method: settings.method,
                cache: settings.cache,
                timeout: settings.timeout,
                dataType: settings.dataType,
                data: {
                    values: settings.data
                },
                charset: settings.charset,
            }, function (ret, err) {
                if (beforeSendClock)
                    clearTimeout(beforeSendClock);


                if (settings.progress !== false)
                    api.hideProgress();

                if (ret) {
                    if (typeof settings.success == 'function')
                        settings.success(ret);

                } else {
                    if (typeof settings.error == 'function')
                        settings.error(err);
                }

                if (typeof settings.complete == 'function')
                    settings.complete();
            })
    }

    u.isInArray = function (arr, val) {
        var testStr = ',' + arr.join(",") + ",";
        return testStr.indexOf("," + val + ",") != -1;
    }

    window.$maoKe = u;
})(window);
