/**
 * cudian-dialog.js
 * @author 流浪男
 * @todo more things to abstract, e.g. Loading css etc.
 * Licensed under the MIT license.
 * http://www.opensource.org/licenses/mit-license.php
 */
(function( window, undefined ) {
    "use strict";
    var auiDialog = function() {
    };
    var isShow = false;
    auiDialog.prototype = {
        params: {
            title:'',
            msg:'',
            buttons: ['取消','确定'],
            input:false
        },
        create: function(params,callback) {
        	var self = this;
            var dialogHtml = '';
            var buttonsHtml = '';
            var headerHtml = params.title ? '<div class="cudian-dialog-header">' + params.title + '</div>' : '<div class="cudian-dialog-header">' + self.params.title + '</div>';
            if(params.input){
                params.text = params.text ? params.text: '';
                var msgHtml = '<div class="cudian-dialog-body"><input type="text" placeholder="'+params.text+'"></div>';
            }else{
                var msgHtml = params.msg ? '<div class="cudian-dialog-body">' + params.msg + '</div>' : '<div class="cudian-dialog-body">' + self.params.msg + '</div>';
            }
            var buttons = params.buttons ? params.buttons : self.params.buttons;
            if (buttons && buttons.length > 0) {
                for (var i = 0; i < buttons.length; i++) {
                    buttonsHtml += '<div class="cudian-dialog-btn" tapmode button-index="'+i+'">'+buttons[i]+'</div>';
                }
            }
            var footerHtml = '<div class="cudian-dialog-footer">'+buttonsHtml+'</div>';
            dialogHtml = '<div class="cudian-dialog">'+headerHtml+msgHtml+footerHtml+'</div>';
            document.body.insertAdjacentHTML('beforeend', dialogHtml);
            // listen buttons click
            var dialogButtons = document.querySelectorAll(".cudian-dialog-btn");
            if(dialogButtons && dialogButtons.length > 0){
                for(var ii = 0; ii < dialogButtons.length; ii++){
                    dialogButtons[ii].onclick = function(){
                        if(callback){
                            if(params.input){
                                callback({
                                    buttonIndex: parseInt(this.getAttribute("button-index"))+1,
                                    text: document.querySelector("input").value
                                });
                            }else{
                                callback({
                                    buttonIndex: parseInt(this.getAttribute("button-index"))+1
                                });
                            }
                        };
                        self.close();
                        return;
                    }
                }
            }
            self.open();
        },
        open: function(){
            if(!document.querySelector(".cudian-dialog"))return;
            var self = this;
            document.querySelector(".cudian-dialog").style.marginTop =  "-"+Math.round(document.querySelector(".cudian-dialog").offsetHeight/2)+"px";
            if(!document.querySelector(".cudian-mask")){
                var maskHtml = '<div class="cudian-mask"></div>';
                document.body.insertAdjacentHTML('beforeend', maskHtml);
            }
            // document.querySelector(".cudian-dialog").style.display = "block";
            setTimeout(function(){
                document.querySelector(".cudian-dialog").classList.add("cudian-dialog-in");
                document.querySelector(".cudian-mask").classList.add("cudian-mask-in");
                document.querySelector(".cudian-dialog").classList.add("cudian-dialog-in");
            }, 10)
            document.querySelector(".cudian-mask").addEventListener("touchmove", function(e){
                e.preventDefault();
            })
            document.querySelector(".cudian-dialog").addEventListener("touchmove", function(e){
                e.preventDefault();
            })
            return;
        },
        close: function(){
            var self = this;
            document.querySelector(".cudian-mask").classList.remove("cudian-mask-in");
            document.querySelector(".cudian-dialog").classList.remove("cudian-dialog-in");
            document.querySelector(".cudian-dialog").classList.add("cudian-dialog-out");
            if (document.querySelector(".cudian-dialog:not(.cudian-dialog-out)")) {
                setTimeout(function(){
                    if(document.querySelector(".cudian-dialog"))document.querySelector(".cudian-dialog").parentNode.removeChild(document.querySelector(".cudian-dialog"));
                    self.open();
                    return true;
                },200)
            }else{
                document.querySelector(".cudian-mask").classList.add("cudian-mask-out");
                document.querySelector(".cudian-dialog").addEventListener("webkitTransitionEnd", function(){
                    self.remove();
                })
                document.querySelector(".cudian-dialog").addEventListener("transitionend", function(){
                    self.remove();
                })
            }
        },
        remove: function(){
            if(document.querySelector(".cudian-dialog"))document.querySelector(".cudian-dialog").parentNode.removeChild(document.querySelector(".cudian-dialog"));
            if(document.querySelector(".cudian-mask")){
                document.querySelector(".cudian-mask").classList.remove("cudian-mask-out");
            }
            return true;
        },
        alert: function(params,callback){
        	var self = this;
            return self.create(params,callback);
        },
        prompt:function(params,callback){
            var self = this;
            params.input = true;
            return self.create(params,callback);
        }
    };
	window.auiDialog = auiDialog;
})(window);